      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
C                                                                        
C     RETURNS THE DOT PRODUCT OF DOUBLE PRECISION DX AND DY.             
C     DDOT = SUM FOR I = 0 TO N-1 OF  DX(LX+I*INCX) * DY(LY+I*INCY)
C     WHERE LX = 1 IF INCX .GE. 0, ELSE LX = (-INCX)*N, AND LY IS
C     DEFINED IN A SIMILAR WAY USING INCY.
C                                                                        
      DOUBLE PRECISION DX(1),DY(1)                                       
      DDOT = 0.D0                                                        
      IF(N.LE.0)RETURN                                                   
      IF(INCX.EQ.INCY) IF(INCX-1) 5,20,60                                
    5 CONTINUE                                                           
C                                                                        
C         CODE FOR UNEQUAL OR NONPOSITIVE INCREMENTS.                    
C                                                                        
      IX = 1                                                             
      IY = 1                                                             
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                  
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                  
      DO 10 I = 1,N                                                      
         DDOT = DDOT + DX(IX)*DY(IY)                                     
        IX = IX + INCX                                                   
        IY = IY + INCY                                                   
   10 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C        CODE FOR BOTH INCREMENTS EQUAL TO 1.                            
C                                                                        
C                                                                        
C        CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 5.    
C                                                                        
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40                                            
      DO 30 I = 1,M                                                      
         DDOT = DDOT + DX(I)*DY(I)                                       
   30 CONTINUE                                                           
      IF( N .LT. 5 ) RETURN                                              
   40 MP1 = M + 1                                                        
      DO 50 I = MP1,N,5                                                  
         DDOT = DDOT + DX(I)*DY(I) + DX(I+1)*DY(I+1) +                   
     1   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4) 
   50 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C         CODE FOR POSITIVE EQUAL INCREMENTS .NE.1.                     
C                                                                        
   60 CONTINUE                                                           
      NS = N*INCX                                                        
          DO 70 I=1,NS,INCX                                              
          DDOT = DDOT + DX(I)*DY(I)                                      
   70     CONTINUE                                                       
      RETURN                                                             
      END                                                                
