      SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)
C                                                                        
C     OVERWRITE SINGLE PRECISION SY WITH SINGLE PRECISION SA*SX +SY.     
C     FOR I = 0 TO N-1, REPLACE  SY(LY+I*INCY) WITH SA*SX(LX+I*INCX) +
C       SY(LY+I*INCY), WHERE LX = 1 IF INCX .GE. 0, ELSE LX = (-INCX)*N,
C       AND LY IS DEFINED IN A SIMILAR WAY USING INCY.
C                                                                        
      REAL SX(1),SY(1),SA                                                
      IF(N.LE.0.OR.SA.EQ.0.E0) RETURN                                    
      IF(INCX.EQ.INCY) IF(INCX-1) 5,20,60                                
    5 CONTINUE                                                           
C                                                                        
C        CODE FOR NONEQUAL OR NONPOSITIVE INCREMENTS.                    
C                                                                        
      IX = 1                                                             
      IY = 1                                                             
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                  
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                  
      DO 10 I = 1,N                                                      
        SY(IY) = SY(IY) + SA*SX(IX)                                      
        IX = IX + INCX                                                   
        IY = IY + INCY                                                   
   10 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                             
C                                                                        
C                                                                        
C        CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 4.    
C                                                                        
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40                                            
      DO 30 I = 1,M                                                      
        SY(I) = SY(I) + SA*SX(I)                                         
   30 CONTINUE                                                           
      IF( N .LT. 4 ) RETURN                                              
   40 MP1 = M + 1                                                        
      DO 50 I = MP1,N,4                                                  
        SY(I) = SY(I) + SA*SX(I)                                         
        SY(I + 1) = SY(I + 1) + SA*SX(I + 1)                             
        SY(I + 2) = SY(I + 2) + SA*SX(I + 2)                             
        SY(I + 3) = SY(I + 3) + SA*SX(I + 3)                             
   50 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C        CODE FOR EQUAL, POSITIVE, NONUNIT INCREMENTS.                   
C                                                                        
   60 CONTINUE                                                           
      NS = N*INCX                                                        
          DO 70 I=1,NS,INCX                                              
          SY(I) = SA*SX(I) + SY(I)                                       
   70     CONTINUE                                                       
      RETURN                                                             
      END                                                               
