      REAL FUNCTION SDOT(N,SX,INCX,SY,INCY)
C                                                                        
C     RETURNS THE DOT PRODUCT OF SINGLE PRECISION SX AND SY.             
C     SDOT = SUM FOR I = 0 TO N-1 OF  SX(LX+I*INCX) * SY(LY+I*INCY),
C     WHERE LX = 1 IF INCX .GE. 0, ELSE LX = (-INCX)*N, AND LY IS
C     DEFINED IN A SIMILAR WAY USING INCY.
C                                                                        
      REAL SX(1),SY(1)                                                   
      SDOT = 0.0E0                                                       
      IF(N.LE.0)RETURN                                                   
      IF(INCX.EQ.INCY) IF(INCX-1)5,20,60                                 
    5 CONTINUE                                                           
C                                                                        
C        CODE FOR UNEQUAL INCREMENTS OR NONPOSITIVE INCREMENTS.          
C                                                                        
      IX = 1                                                             
      IY = 1                                                             
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                  
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                  
      DO 10 I = 1,N                                                      
        SDOT = SDOT + SX(IX)*SY(IY)                                      
        IX = IX + INCX                                                   
        IY = IY + INCY                                                   
   10 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                             
C                                                                        
C                                                                        
C        CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 5.    
C                                                                        
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40                                            
      DO 30 I = 1,M                                                      
        SDOT = SDOT + SX(I)*SY(I)                                        
   30 CONTINUE                                                           
      IF( N .LT. 5 ) RETURN                                              
   40 MP1 = M + 1                                                        
      DO 50 I = MP1,N,5                                                  
        SDOT = SDOT + SX(I)*SY(I) + SX(I + 1)*SY(I + 1) +                
     1   SX(I + 2)*SY(I + 2) + SX(I + 3)*SY(I + 3) + SX(I + 4)*SY(I + 4) 
   50 CONTINUE                                                           
      RETURN                                                             
C                                                                        
C        CODE FOR POSITIVE EQUAL INCREMENTS .NE.1.                       
C                                                                        
   60 CONTINUE                                                           
      NS=N*INCX                                                         
      DO 70 I=1,NS,INCX                                                  
        SDOT = SDOT + SX(I)*SY(I)                                        
   70   CONTINUE                                                         
      RETURN                                                             
      END                                                                
